<template>
  <header class="header">
    <section class="header__inner">
      <div class="header__left">
        <router-link to="/">
          <div class="logo"></div>
        </router-link>
        <section class="header__buttons">
          <router-link to="/play">
            <md-button>Explore</md-button>
          </router-link>
          <router-link to="/genres">
            <md-button>Genres</md-button>
          </router-link>
        </section>
      </div>
      <header-search></header-search>
      <transition name="fade">
        <header-search-results v-if="isOpened" ref="searchResults" v-bind:items="items" v-bind:isLoading="processing"></header-search-results>
      </transition>
    </section>
  </header>
</template>

<script>
import Vue from 'vue';
import Component from 'vue-class-component';
import { State } from 'vuex-class';
import HeaderSearch from './Search';
import HeaderSearchResults from './SearchResults';

@Component({
  components: {
    'header-search': HeaderSearch,
    'header-search-results': HeaderSearchResults,
  },
})
export default class Header extends Vue {
  @State(state => state.search.isOpened)
  isOpened;
  @State(state => state.search.processing)
  processing;
  @State(state => state.search.searchResults)
  items;

  openSearch() {
    this.$store.dispatch('startSearch');
  }

  closeSearch() {
    this.$store.dispatch('closeSearch');
  }
}
</script>

<style lang="stylus">
.header
  position fixed
  top 0
  left 0
  width 100%
  z-index 100
  display flex
  height 60px
  justify-content space-between
  align-items center
  background transparent
  transform translateZ(0)
  perspective 600

  &__inner
    position relative
    width 100%
    max-width 1092px
    min-width 1092px
    padding 0 16px
    box-shadow rgba(41,41,41,.2) 0px 1px 3px 0px, rgba(0,0,0,.14) 0px 1px 1px 0px, rgba(0,0,0,.12) 0px 2px 1px -1px
    margin auto
    display flex
    justify-content space-between
    align-items center
    background-color #1c212c

  &__left
    display flex
    align-items center

  .logo
    background-image url('../../assets/logo.png')
    background-repeat no-repeat
    background-position center
    width 120px
    height 60px
    display inline-block
    vertical-align middle
    cursor pointer
  
  &__buttons
    display flex
    margin-left 20px

    .md-button
    .md-button .md-ink-ripple
      border-radius 0 !important
      color #fff

  .fade-enter-active
  .fade-leave-active
    transition all .4s
    transform rotateX(0)

  .fade-enter
  .fade-leave-to
    opacity 0
    transform rotateX(15deg)
</style>